#include <pins_arduino.h>
#include <Arduino.h>
#include <NilRTOS.h>
#include <Ping.h>

SEMAPHORE_DECL(PingSem, 0);

byte PingSetup = false;
volatile long duration = 0;

void PingInterrupt() {
  NIL_IRQ_PROLOGUE();
  
  if (digitalRead(2))
    duration = micros();
  else
  {
    duration = micros() - duration;
    nilSemSignalI(&PingSem);
  }
  
  NIL_IRQ_EPILOGUE();
}

long DoPing(int Trig, int Echo)
{
  if (!PingSetup)
  {
    pinMode(Trig, OUTPUT);
    digitalWrite(Trig, LOW);
    
    pinMode(Echo, INPUT);
    digitalWrite(Echo, HIGH);    

    attachInterrupt(Echo - 2, &PingInterrupt, CHANGE);
    
    PingSetup = true;
  }
  
  // The PING))) is triggered by a HIGH pulse of 2 or more microseconds.
  digitalWrite(Trig, HIGH);
  delayMicroseconds(5);
  digitalWrite(Trig, LOW);
  
  nilSemWait(&PingSem);

  return duration / 148;
}


